<?php
class fssStats {
    var $subscribers;
    var $hits;
    var $last_update;
    var $oldest_record;
    var $newest_record;
    var $uri;
    var $msg;
    var $yesterday;
    var $today;
    var $installed=false;


    function fssStats(){

        $this->install();   //Run the Installer.

        $uri = get_option('feedsubstats_uri');  //FeedBurner URI:
        $this->uri=$uri;

        $this->currentStats();  //Update variables with available data.

        $this->today=date("Y-m-d",mktime(0, 0, 0, date("m")  , date("d")-1, date("Y")));
        $yesterday  = mktime(0, 0, 0, date("m")  , date("d")-2, date("Y"));
        $yesterday=date("Y-m-d",$yesterday);
        $this->yesterday=$yesterday;

        if ($this->yesterday > $this->newest_record){ //Check to see if we have the latest stats.
            $this->remoteOpen(); // Get the newest stats.
            $this->currentStats();  // Reset the variables to the new stats.

        }

        if ($this->oldest_record > '2008-01-01') {  //Is the oldest record in the database too recent for 1-1-2008?
            $this->remoteOpen(TRUE); //Archive The Old Data.
        }
    }

    function install(){
        // Create the database table if it doesn't exist.
        global $wpdb;
        $q="CREATE TABLE IF NOT EXISTS `fssstats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` varchar(150) NOT NULL,
  `stats` int(11) NOT NULL,
  `hits` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 AUTO_INCREMENT=1;";
        $r=$wpdb->query($q);

    }

    function fssHeader(){
      /* This is the head CSS and JavaScript. */
        $blogurl=get_option("siteurl");
        echo '   <!--[if IE]><script language="javascript" type="text/javascript" src="' . $blogurl . '/wp-content/plugins/feed-subscriber-stats/js/excanvas.pack.js"></script><![endif]-->

    <script language="javascript" type="text/javascript" src="' . $blogurl . '/wp-content/plugins/feed-subscriber-stats/js/jquery.flot.pack.js"></script>';
        echo "
    <style type='text/css'>
    span.circulation {
        color:#FC7F01;
        font-size:28px;
        display:block;
padding-top:15px;
padding-left:10px;
    }
    </style>
    ";
    }


    function currentStats() {
        global $wpdb;
        $q="SELECT `stats`,`hits` FROM fssstats ORDER BY `date` DESC LIMIT 1";
        $r=$wpdb->get_results($q,ARRAY_A);
        $this->subscribers=$r[0]['stats'];
        $this->hits=$r[0]['hits'];
        $this->last_update=$r[0]['date'];

        //Oldest Record:
        $q="SELECT `date` FROM fssstats ORDER BY `date` ASC LIMIT 1";
        $this->oldest_record=$wpdb->get_var($q);

        //Newest Record:
        $q="SELECT `date` FROM fssstats ORDER BY `date` DESC LIMIT 1";
        $this->newest_record=$wpdb->get_var($q);


        if ($this->newest_record == $this->today){
            $q="DELETE FROM fssstats WHERE `date`='$this->today'";
            $r=$wpdb->query($q);
            //Newest Record again:
            $q="SELECT `date` FROM fssstats ORDER BY `date` DESC LIMIT 1";
            $this->newest_record=$wpdb->get_var($q);
        }
    }

    function remoteOpen($archive=FALSE){
        global $wpdb;
        $uri=$this->uri;

        //Feed URL:
        $url="https://feedburner.google.com/api/awareness/1.0/GetFeedData?uri=$uri&dates=$this->yesterday";
        if ($archive){
            $url="https://feedburner.google.com/api/awareness/1.0/GetFeedData?uri=$uri&dates=2008-01-01,$this->yesterday";
            // Delete old records.
            $q="DELETE FROM fssstats";
            $r=$wpdb->query($q);
        }
        $contents = wp_remote_fopen($url);
        preg_match_all('/date="(.*?)" circulation="(.*?)" hits="(.*?)"/msi',$contents,$match);
        // $match[1] == Date
        // $match[2] == Circulation
        // $match[3] == Hits
        foreach ($match[1] as $k=>$v){
            $theDate=$match[1][$k];
            $circulation=$match[2][$k];
            $hits=$match[3][$k];
            $q="INSERT INTO fssstats SET `date`='$theDate',`stats`='$circulation',`hits`='$hits'";
            $r=$wpdb->query($q);
        }
    }

}

?>
