<?php
/*
Plugin Name: Feed Subscriber Stats
Plugin URI: http://www.allancollins.net/368/feed-subscriber-stats-3/
Description: This plugin will show the number of subscribers according to FeedBurner.
Author: Allan Collins
Version: 3.0.6
Author URI: http://www.allancollins.net
*/
/*
Copyright (C) 2008-2009 Allan Collins

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

//Includes:
include "classes/fssStats.php";

//Actions:
add_action('init', 'fss_register');
add_action('admin_head', 'feedsubstats_css');
add_action('wp_dashboard_setup', 'feedsubstats_widget' );
add_action('admin_menu', 'fss_add_pages');

//Start Up The FSS Object:
$fssStats=new fssStats();

/*Dashboard Notice / Subscriber Count: */
function feedsubstats_widget() {
    if (function_exists(wp_add_dashboard_widget)) {
        wp_add_dashboard_widget('feed_subscriber_stats', 'Feed Subscriber Stats', 'fssShow');
    }else{
        add_action('activity_box_end','fssShow');
    }
}

/*Data to appear in Dashboard Notice / Subscriber Count area: */
function fssShow(){
    global $fssStats;
    $thePath=get_option('siteurl');
    if ($fssStats->msg != ''){
        echo $fssStats->msg;
        echo "<br/><br/><a href=\"admin.php?page=fssSettings\"><b>Modify Your Settings</b></a>";
        return false;
    }
    echo "<img src=\"$thePath/wp-content/plugins/feed-subscriber-stats/images/rss.jpg\" style=\"float:left\"/>";
    echo "<span class=\"circulation\">$fssStats->subscribers Subscribers</span>";
    echo "<br style=\"clear:both\" />";
    echo "<a href=\"admin.php?page=feed-subscriber-stats/feedsubstats.php\"><small>View Full Stats</small></a><br/><br/>";
    echo "<div align=\"right\"><small>Stats For: $fssStats->newest_record</small></div>";
}

/*Header CSS from the FSS Object: */
function feedsubstats_css(){
    global $fssStats;
    $fssStats->fssHeader();
}

/*Add Management Pages: */
function fss_add_pages() {
    if (function_exists('add_menu_page')){
        add_menu_page('Feed Stats', 'Feed Stats', 8, __FILE__, 'fssPage');
        add_submenu_page(__FILE__, 'Settings', 'Settings', 8,'fssSettings', 'fssSettings');
    }
}

/*Statistics Page.  Utilizes Flot for graphing purposes: */
function fssPage(){
    global $wpdb;
    global $fssStats;
    echo "<div class=\"wrap\"><h2>Feed Subscriber Stats</h2></div>";
    $q="SELECT `date`,`stats`,`hits` FROM fssstats ORDER BY `date` ASC";
    $r=$wpdb->get_results($q,ARRAY_A);
    if (!$r){
        echo "<b>There was a problem.</b><br/><br/>No Data Found.";
        echo "<br/><br/><a href=\"admin.php?page=fssSettings\"><b>Modify Your Settings</b></a>";
        return false;
    }
    $data="null";
    $data2="null";
    foreach ($r as $v){
        $month=$v['date'];
        $hits=$v['hits'];
        $month=strtotime($month) * 1000;
        $stats=$v['stats'];
        $data.=",[$month,$stats]";
        $data2.=",[$month,$hits]";
    }
    $year=date('Y');
    echo '<script language="javascript" type="text/javascript">
jQuery(function ($) {
    var d2 = [' . $data . '];
   var d3 = [' . $data2 . '];

    $.plot($("#placeholder"), [ d2 ], { xaxis: {
            mode: "time",
            minTickSize: [1, "month"],
            min: (new Date("2008/01/01")).getTime(),
            max: (new Date("' . $year . '/12/31")).getTime()
        }
        });

    $.plot($("#placeholder2"), [ d3 ], { xaxis: {
            mode: "time",
            minTickSize: [1, "month"],
            min: (new Date("2008/01/01")).getTime(),
            max: (new Date("' . $year . '/12/31")).getTime()
        }
        });
});
</script>';
    echo "<b>Subscribers for $fssStats->newest_record:</b> $fssStats->subscribers<br/><b>Hits for $fssStats->newest_record:</b> $fssStats->hits <br/><br/>";
    echo '<b>Subscribers:</b><br/><div id="placeholder" style="width:600px;height:300px;"></div>';
    echo "<hr/><b>Hits :</b><br/>";
    echo '<div id="placeholder2" style="width:600px;height:300px;"></div>';
}

/*FSS Settings / FeedBurner URI: */
function fssSettings(){
    global $wpdb;
    echo "<div class=\"wrap\"><h2>Feed Subscriber Stats Settings</h2>";
    if (isset($_POST['feedsubstats_uri'])){
        $uri=$_POST['feedsubstats_uri'];
        if (substr($uri,strlen($uri) - 1) == '/'){  //Checks for trailing slash(/)
            $uri=substr($uri,0,strlen($uri) - 1);   //Then removes it.
        }
        $q="DELETE FROM fssstats";
        $r=$wpdb->query($q); //Removes all stats data from database table, since URI has changed.
        update_option('feedsubstats_uri',$uri);
        echo "<div id=\"message\" class=\"updated fade\">FeedBurner Stats Have Been Changed.</div><br/>";
    }
    echo "<br/><br/>";
    echo "<b>FeedBurner URI:</b><br/>";
    echo "<form action=\"admin.php?page=fssSettings\" method=\"post\">";
    echo "http://feeds2.feedburner.com/<input type=\"text\" name=\"feedsubstats_uri\" value=\"" . get_option('feedsubstats_uri') . "\" /> ";
    echo "<input type=\"submit\" value=\"Submit\" />";
    echo "</div>";
}

/*Sidebar Widget: */
function fss_register() {
    function fss_widget($args) {
        global $fssStats;
        extract($args);
        echo $before_widget;
        echo $before_title . $after_title;
        $circulation=$fssStats->subscribers;
        $fssText=str_replace("[fss_subscribers]",$circulation,get_option("fss_subscribers"));
        echo $fssText;
        echo $after_widget;
    }
    register_sidebar_widget('Feed Subscriber Stats','fss_widget');
    register_widget_control("Feed Subscriber Stats", fss_widgetOption);
    function fss_widgetOption() {
        if (isset($_POST['fss_subscribers'])){
            update_option('fss_subscribers',$_POST['fss_subscribers']);
        }
        echo '<em>Example: <br/>There are [fss_subscribers] subscribers to this blog.</em><br/><br/><textarea name="fss_subscribers" style="width:200px;height:100px;">' . get_option('fss_subscribers') . '</textarea><br/>';
    }
}

function fss_subscribers() {
    global $fssStats;
    echo $fssStats->subscribers;
}

?>